/////////////////////////////////////////////////////////////////////////////
//                                                                         //
//                        PE.C     (PHDM's EDITOR)                         //
//                                                                         //
// Copyright (C) 2000-2014  Philippe Demeester                             //
// Bugs report: phdm@perso.be                                              //
// Web site   : http://phdm.webay.be                                       //
//                                                                         //
// This program is free software; you can redistribute it and/or           //
// modify it under the terms of the GNU General Public                     //
// License as published by the Free Software Foundation; either            //
// version 2.1 of the License, or (at your option) any later version.      //
//                                                                         //
// This program is distributed in the hope that it will be useful,         //
// but WITHOUT ANY WARRANTY; without even the implied warranty of          //
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU       //
// Library General Public License for more details or write to the         //
// Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. //
//                                                                         //
/////////////////////////////////////////////////////////////////////////////

/****************************************************************************
* display.c 
* All display functions
* Version 1.0
*****************************************************************************/


#include "pe.h"
// some str utils for integers...
void int_strcpy(int *target, int *src)
{
int i=0;
while (src[i]!=0){
	target[i]=src[i];
	i++;
	};
target[i]=0; // close it
}

int int_strlen(int *src)
{
int i=0;
while (src[i]!=0){
	i++;
	};
return(i);
}

/*check the line lgth on display */
int chk_dspl_len(char c)
{
int i,j,k;
int str[W];
k=j=i=0;
int_strcpy(str,txt[curr_line]);
if (c!=0){
  k=int_strlen(str);
/* shift right */
  while (k>=curr_pos){str[k+1]=str[k]; k--;};
  str[curr_pos]=c;
  };
/* compute the line display len */
while (str[i]!=0){
  if (str[i]!= KEY_TAB)j++;
  else { /* tab is locating the cursor on fixed positions */
    k = j / TAB_VAL;
    j = (k+1) * TAB_VAL;
    };
  i++;
  };
return(j);
}

/* computes x cursor position  T**T***T**   */
int set_curs_pos(int set)
{
int i=0,j=0,k=0,l=0,tab=0;
if (txt[curr_line][curr_pos]==KEY_TAB)tab=1;
for (i=0;i<=curr_pos;i++){
  if (txt[curr_line][i]!= KEY_TAB)j++;
  else {
    l=j;
    k = j / TAB_VAL; j = (k+1)*TAB_VAL;
    switch (chr){
      case KEY_LEFT : ; break;
      default: ;
      };
    };
  };
if (tab) j=l+1;  
if (set==1)curs_x = j-1;
return(j-1);
}

/* computes x cursor position for an index */
int get_curs_pos(int ind)
{
int i=0,j=0,k=0;
for (i=0;i<=ind;i++){
  if (txt[curr_line][i]!= KEY_TAB)j++;
  else {
    k = j / TAB_VAL; j = (k+1)*TAB_VAL;
    switch (chr){
      case KEY_LEFT : ; break;
      default: ;
      };
    };
  };
return(j-1);
}
/* find curr_pos from curs_x */
int get_curr_pos(int x)
{
int eol, i, j;
if (x==0) return (0);
eol=eof_line();
i=0;
while (i<eol){
	j=get_curs_pos(i);
	if (j>=x)return (i);
	i++;
	}
return(eol);
}



void set_xshift(){
int l,p;
/* Where comes the cursor? */
p=set_curs_pos(0);
/* adjust xshift */
l=p/(x_max/2);
last_xshift=xshift;
if (l>=2)
xshift=((l-1)*(x_max/2));
else xshift=0;
}

/* Proc to insert char in line
 * 
 * check if there is W(256) is reached.
 * find the x cursor position
 * shift the x screen with the cursor
 **/
void insert()
{
int i;
/* chk if enough space in the current line buffer */
//printf("\n%u\n",c);
i=eof_line();
if (i >= W-1){
  bip();
  reloc();
  return;
  };
set_xshift();
/* shift txt right */
while (i > curr_pos){
    txt[curr_line][i] = txt[curr_line][i-1];
    i--;
  };
txt[curr_line][curr_pos]=c;
//printf("\n%u\n",txt[curr_line][curr_pos]);
if(curr_pos < W-1)curr_pos++;
else {
  bip();
  return;
  };
displ_line();
put_cur_pos();
last_inst_x=curr_pos;
last_inst_y=curr_line;
reloc();  
del_blk_flg = 1;
}

/* proc to locate the cursor */
void loc(int y, int x)
{
move(y, x);
}

/* proc to relocate the cursor */
void reloc()
{
move(curs_y, set_curs_pos(1)-xshift);
}

/* proc return the end of line position */
int eof_line()
{
int i=0;
while (txt[curr_line][i]!=0)i++;
return(i);
}

int eof_line_pos()
{
int i=0;
while (txt[curr_line][i]!=0){
	if (txt[curr_line][i]==KEY_TAB)i=i+TAB_VAL;
	else i++;
	};
return(i);
}


/**
 * proc to display a line
 * If the xshift has changed, redo the full screen
*/

void displ_line()
{
if( last_xshift != xshift )redo_full_scr();
else put_line();
}

/**
 * proc to print a line
 *
 * To get a correct representation, let build a full line and cut
 * the right part to display it.
 **/

/**
 * to_utf8
bytes | bits | representation
     1 |    7 | 0vvvvvvv - 128
     2 |   11 | 110vvvvv 10vvvvvv  8*256 - 2048
     3 |   16 | 1110vvvv 10vvvvvv 10vvvvvv  256*256  - 65536
     4 |   21 | 11110vvv 10vvvvvv 10vvvvvv 10vvvvvv 65536*32 - 2097152
**/
int to_utf8( int *line)
{
unsigned int ch,i,j,lch,hch,tch,fch;
int locline[1024];
int_strcpy(locline, line);
i=j=0;
for (i=0;i<int_strlen(line);i++){
	if (locline[i]<128){line[j]=locline[i]; j++;}
	else if (locline[i]<2048){ // 2 bytes
		ch=locline[i];
		lch=ch&0x03F;
		lch=lch|0x080; //put b10 in front
		hch=ch&0x7C0;
		hch=hch>>6;
		hch=hch|0xC0;//put b110 in front
		line[j]=hch; j++;
		line[j]=lch; j++;
		}
	else if (locline[i]<65536){ // 3 bytes
		ch=locline[i];
		lch=ch&0x03F;
		lch=lch|0x080; //put b10 in front
		hch=ch&0x0FC0;  // 0000 1111 1100 0000
		hch=hch>>6;
		hch=hch|0x080; //put b10 in front
		tch=ch&0x0F000;  // 1111 0000 0000 0000
		tch=tch>>12;
		tch=tch|0xE0;//put b1110 in front
		line[j]=tch; j++;
		line[j]=hch; j++;
		line[j]=lch; j++;
		}
	else{ // 4 bytes
		ch=locline[i];
		lch=ch&0x03F;
		lch=lch|0x080; //put b10 in front
		hch=ch&0x0FC0;  // 0000 1111 1100 0000
		hch=hch>>6;
		hch=hch|0x080; //put b10 in front
		tch=ch&0x3F000;  //  0011 1111 0000 0000 0000
		tch=tch>>12;
		tch=tch|0x080; //put b10 in front
		fch=ch&0x01C0000;  // 0001 1100 0000 0000 0000 0000
		fch=fch>>18;
		fch=fch|0xF0;//put b11110 in front
		line[j]=fch; j++;
		line[j]=tch; j++;
		line[j]=hch; j++;
		line[j]=lch; j++;		
		};
	};
return(j);
}

void put_line()
{
int line[1024], *ptr;
int i,j;
char charline[1024];
//gsize s;
//gchar *g_s;
i=j=0;
line[0]=0;
for (i = 0; i < eof_line(); i++){
  if (txt[curr_line][i]!= KEY_TAB){
    line[j]=txt[curr_line][i];
    j++;
    }
  else{ // replace tab with spaces
    int n;
    n=get_curs_pos(i);
    while (j<=n){
      line[j]=' ';
      j++;
      };
    };
  };
line[j]=0;
cll();
ptr=&line[xshift];
if (ptr < &line[j]){ // do not prt if no txt
  if (int_strlen(ptr)>x_max)line[xshift+x_max]=0;
  loc(curs_y, 0 );
	if(utf_8==0){
		//printf("i=%u\n",i);
		int j=0;
		for (i=xshift;i<int_strlen(line);i++){
			charline[j]=line[i]&0x0ff;
			j++;
			};
		charline[j]=0;
		addstr(charline);
		//printw("%s",ptr);
	}	
	else{ // convert to UTF-8
		// shift the line at ptr 
		i=0;
		while(line[xshift+i]>0){
			line[i]=line[xshift+i];
			i++;
			};		
		line[i]=0;
		to_utf8(line);
		for (i=0;i<int_strlen(line);i++){charline[i]=line[i]&0x0ff;};
		charline[i]=0;
		addstr(charline);
		//printw("%s",charline);
		/*
		g_s=g_convert(ptr, -1,"UTF-8", "ISO-8859-15", NULL, &s, NULL);
		if (g_s!=NULL){
			addstr(g_s);
			g_free(g_s);
			};
		*/
		};
  };
}
/* redo screen from curs_y */
void redo_scr()
{
int i,j;
i=curs_y;
j=curr_line;
while (curs_y<= y_max){
  cll();
  put_line();
  curs_y++;
  curr_line++;
  };
curs_y=i;
curr_line=j;
}
/* redo screen from top */
void redo_full_scr(){
int tmp_curr_line, tmp_curs_y;

tmp_curr_line=curr_line;
curr_line=curr_line - curs_y;
tmp_curs_y=curs_y;
curs_y=0;
redo_scr();
curr_line=tmp_curr_line;
curs_y=tmp_curs_y;

}

/* display the msg on the screen bottom */
void info(char *msg)
{
int ch,x;
char *txt = 
"                                                                             ";
x=(x_max-78)/2;
loc(y_max + 1,x);
color(2);
printw("%s",txt);
refresh();
loc(y_max + 1,x);
printw("%s",msg);
refresh();
if (comfirm_flg){
  printw("%s",gettext("Hit any key ..."));
  ch=getch();
  }
else
  sleep(3);
put_cmd();
put_line_num();
put_blk_status();
color(1);
reloc();
tut();
}

/* display the msg on the screen bottom & ret anwser*/
int ask(char *msg)
{
int ch,x;
char *txt = 
"                                                                             ";
x=(x_max-78)/2;
loc(y_max + 1,x);
color(2);
printw("%s",txt);
refresh();
loc(y_max + 1,x);
printw("%s",msg);
refresh();
ch=getch();
put_cmd();
put_line_num();
put_blk_status();
color(1);
reloc();
tut();
if (ch=='y')return(1);
else return(0);
}

/* proc to print the cmd line */
void put_cmd()
{
int x,tmp_y;
/* clear the cmd line */
tmp_y=curs_y;
curs_y=y_max + 1;
cll();
curs_y=tmp_y;
/* set the cmd in the middle */
x=(x_max-78)/2;
loc(y_max + 1,x);
color(2);
printw("%s",gettext(
"F2=Save F3=MrkB F4=InsB F5=DelB F6=Find F7=Print F8=Quit F9=Load           "));
put_line_num();
put_blk_status();
color(1);
reloc();
}

/* proc to print the intro line */
void intro()
{
char *msg =
"<<<<<<<<<<<<<<<< PhDm's editor V1.2  Copyright(C) 2000-2014 >>>>>>>>>>>>>>";
int x;
x=(x_max-strlen(msg))/2+1;
loc(y_max + 1,x);
color(4);
printw("%s",msg);
color(1);
reloc();
refresh();
}

/* proc to print the current line # */
void put_line_num()
{
int x;
x=(x_max-78)/2;
loc(y_max + 1,x+74);
color(4);
printw("%s","      ");
loc(y_max + 1,x+74);
printw("L%u",curr_line + 1);
put_cur_pos();
color(1);
reloc();
}

/* proc to print the current cursor pos # */
void put_cur_pos()
{
int x;
x=(x_max-78)/2;
loc(y_max + 1,x+69);
color(4);
printw("%s","    ");
loc(y_max + 1,x+69);
set_curs_pos(1);
printw("C%u",curs_x + 1);
color(1);
reloc();
}

void put_ym() //debug
{
loc(y_max + 1,69);
color(4);
printw("%s","    ");
loc(y_max + 1,69);
printw("Y=%u",ym );
color(1);
reloc();
}

void put_blk_status()
{
int x;
x=(x_max-78)/2;
color(4);
loc(y_max + 1,x+65);
printw("B=%u",blk_flg);
color(1);
reloc();
}

/* proc to clear the scr */
void cls()
{
int i;
char empty[x_max+2]; // GNU C only!!!
i=0;
while (i<(x_max+1)){empty[i]=' ';i++;};
empty[i]=0;
i=0;
color(1);
while (i<(y_max +2))
  { loc(i,0);
    printw("%s",empty);                            
    i++;
  };
}

/* proc to clear a line */
void cll()
{
char empty[258];
int i=0;

while (i<(x_max+1)){empty[i]=' ';i++;};
empty[i]=0;
loc(curs_y,0);
printw("%s",empty);
reloc();                            
}

/* retrieve the cursor pos after a TAB */
void init_tab_len()
{
int y,x;
reloc();
txt[0][0]= KEY_TAB;
printw("%s",txt[0]);
getyx(win,y,x);
TAB_VAL=x;
//fprintf(stderr,"x=%u y=%u\n",x,y);
txt[0][0]=0;
loc(0,0);
}

/* a signal from resize is arrived */
void resize_handler (int signum)
{
if (signum==SIGWINCH)
  {
  refresh();
  getmaxyx(win,ym,xm);  
  x_max=xm-1;  
  y_max=ym-2;  
  put_cmd();
  put_line_num(); 
  redo_full_scr();
  reloc();
  };  
}
/* a chr resize is arrived */       
void resize_terminal()
{
int ch;
ch=getch(); // clear the -1 that follows the 410 KEY_RESIZE
getmaxyx(win,ym,xm);  
x_max=xm-1;  
if (x_max>255)x_max=255;
y_max=ym-2;  
put_cmd();
put_line_num(); 
redo_full_scr();
reloc();
}

/* modify the colors to be use */
void color(int color)
{
attron(COLOR_PAIR(color));
current_color=color;
}
/* proc to init the screen */
void init()
{
win=initscr();
getmaxyx(win,ym,xm);
//fprintf(stderr, "y=%u x=%u\n", ym,xm);
noecho();
cbreak();
if (!has_colors())quit();
if (!start_color())quit();
//init_pair(1,COLOR_YELLOW,COLOR_BLUE);
init_pair(1,COLOR_BLACK,COLOR_WHITE);
//init_pair(1,COLOR_WHITE,COLOR_BLACK);
init_pair(2,COLOR_BLACK,COLOR_YELLOW);
init_pair(3,COLOR_YELLOW,COLOR_BLUE);
init_pair(4,COLOR_GREEN,COLOR_BLACK);
keypad(stdscr,TRUE);
//immedok(win,TRUE);
}

/* a bit of acoustic ! */
void bip()
{
if (tit_flg==0)return;
beep();
refresh();
usleep(200000);
}

void tit()
{
if (tit_flg==0)return;
ioctl(0,KDMKTONE,(66<<16)+500);
usleep(66000);
}
void tut()
{
if (tit_flg==0)return;
ioctl(0,KDMKTONE,(66<<16)+5000);
usleep(66000);
}
void titat()
{
if (tit_flg==0)return;
ioctl(0,KDMKTONE,(66<<16)+500);
usleep(66000);
ioctl(0,KDMKTONE,(66<<16)+1000);
usleep(66000);
}

void tatit()
{
if (tit_flg==0)return;
ioctl(0,KDMKTONE,(66<<16)+800);
usleep(66000);
ioctl(0,KDMKTONE,(66<<16)+600);
usleep(66000);
}

void titatut()
{
if (tit_flg==0)return;
ioctl(0,KDMKTONE,(66<<16)+500);
usleep(66000);
ioctl(0,KDMKTONE,(66<<16)+1000);
usleep(66000);
ioctl(0,KDMKTONE,(66<<16)+1500);
usleep(66000);
}
